#include <cstdint>
#include <cstdlib>
#include "type.h"
#include "typetree.h"
#include "nametree.h"

extern TypeTree DB_TYPE;
extern NameTree DB_NAME;

struct List {
    uint64_t capacity;
    uint64_t length;
    void*    data;

    void* allocate(size_t size);

    List();
    ~List();
};

struct Schema {
    struct Row {
        uint16_t type;
        uint16_t offset;
    };
    struct Node {
        uint16_t keyword;
        uint16_t index;
    };

    uint16_t capacity;
    uint16_t length;

    Node* nodes;
    Row*  members;

    Schema();
    ~Schema();

    void* allocate();
};
