#include <cstdint>

namespace Type {

enum Tag {
    Null    = 0x01,
    Boolean = 0x02,
    Natural = 0x10,
    Integer = 0x11,
    Block   = 0x1e,
    String  = 0x1f,
    Set     = 0x21,
    Array   = 0x22,
    List    = 0x23,
    Trie    = 0x27,
    Map     = 0x28,
    Record  = 0x4e,
    Schema  = 0x4f,
};

struct Info {
    uint16_t Tag;
    uint16_t Size;

    Info(uint16_t tag, uint16_t size)
        :Tag(tag), Size(size) { }
};

const Info Null    (Tag::Null, 0);
const Info Boolean (Tag::Boolean, 0);
const Info Natural (Tag::Natural, 8);
const Info Integer (Tag::Integer, 8);
const Info Block   (Tag::Block, -1);
const Info String  (Tag::String, -1);
const Info Set     (Tag::Set, -1);
const Info Array   (Tag::Array, -1);
const Info List    (Tag::List, -1);
const Info Trie    (Tag::Trie, -1);
const Info Map     (Tag::Map, -1);
const Info Record  (Tag::Record, -1);
const Info Schema  (Tag::Schema, -1);

}
